<?php

namespace Plugin\PunchCommerce\src;

use JTL\Plugin\PluginInterface;
use JTL\Session\Frontend;
use JTL\Shop;

class BasketHookHandler
{
    public PluginInterface $plugin;

    public function __construct(PluginInterface $plugin)
    {
        $this->plugin = $plugin;
    }

    public function __invoke()
    {
        $smarty = Shop::Smarty();
        $config = $this->plugin->getConfig();

        $id = Frontend::get('punchcommerce_session_id');

        $transform = new TransformBasketForPunchCommerce();
        $result = $transform($config);

        $hostname = $config->getValue('punchcommerce_url');
        $service = "/gateway/v3/return";
        $url = $hostname . $service;

        $smarty->assign('id', $id);
        $smarty->assign('payload', json_encode($result->jsonSerialize(), JSON_THROW_ON_ERROR));
        $smarty->assign('target', $url);
    }
}
